;---------------------------------------------------------------------------------------------------#!
;---------------------------------------------------------------------------------------------------#!
;-----------------------------{{Author: Mustafa Okasha}}--------------------------------------------#!
;---------------------------{{Project: BasicCalculator 2.0}}----------------------------------------#!
;---------------------------{{System: 8051 microcontroller}}----------------------------------------#!
;------------------------------{{Released at: 12/6/2013}}-------------------------------------------#!
;---------------------------------------------------------------------------------------------------#!
;---------------------------------------------------------------------------------------------------#!
N1		EQU 	30H								;#!Ram byte location holds first oeprand 
N2		EQU		31H								;#!Ram byte locations holds second operand
OP		EQU		32H								;#!Ram byte location holds operation ascii code
R		EQU		33H								;#!Ram byte location holds result
H		EQU		34H								;#!Ram byte location holds result's high byte 
F		EQU		35H								;#!Ram byte location holds result's float number
SIGN	EQU		36H								;#!Ram byte location holds result's sign
TEMP	EQU		37H								;#!Ram byte location holds temporary data
DIF		BIT		0AH								;#!Digit input flag bit for(0,1,2,3,4,5,6,7,8,9)
OIF		BIT		0BH								;#!Operator input flag bit for (+,-,*,/)
AIF		BIT		0CH								;#!Assignment operator flag bit(=)
PZF		BIT		0DH								;#!Flag bit for not print zeros before result 
		ORG 	0H								;#!Orginate at rom address 0000H			
		AJMP	MAIN							;#!Absoulte jump to main routine 	
;--------------------------------------------------------------------------------------------------#!
;--------------------------------------------------------------------------------------------------#!
		ORG 	30H								;#!Orginate at rom adress 0030H
MAIN:	ACALL 	memoryInit						;#!CALL memory initialization subroutine
		ACALL 	lcdInit							;#!CALL lcd initialization subroutine
		ACALL 	readInput						;#!CALL read input subroutine
		ACALL	calculateResult					;#!CALL calculate result subroutine
		ACAll 	printOutput						;#!CALL print output subroutine
		AJMP 	MAIN							;#!return and start the program once more
;--------------------------------------------------------------------------------------------------#!
;--------------------------------------------------------------------------------------------------#!
memoryInit:										
		CLR		A								;#!Clear ACC						
		MOV		N1,A							;#!Clear first operand location in ram 
		MOV		N2,A							;#!Clear second operand location in ram 
		MOV		OP,A							;#!Clear operation location in ram 
		MOV		R,A								;#!Clear result location in ram
		MOV		H,A								;#!Clear result's high byte location in ram
		MOV		F,A								;#!Clear result's float number location in ram
		MOV		SIGN,A							;#!Clear sign location in ram
		MOV		TEMP,A							;#!Clear result location in ram
		CLR		C								;#!Clear carry bit
		MOV		DIF,C							;#!Clear digit flag bit		
		MOV		OIF,C							;#!Clear operator flag bit
		MOV		AIF,C							;#!Clear assignment operator flag bit
		MOV		PZF,C							;#!Clear print zero flag bit
		RET										;#!return to MAIN routine
;--------------------------------------------------------------------------------------------------#!
lcdInit:										
		MOV 	DPTR,#MYCOM						;#!Set DPTR to look-up table's address
C1: 	CLR 	A								;#!Clear ACC
		MOVC 	A,@A+DPTR						;#!Get code from look-up table and placing it into ACC
		ACALL 	COMMWRT							;#!CALL LCD command write subroutine
		INC 	DPTR							;#!Increment DPTR  <DPTR = DPTR + 1>
		JZ 		C2								;#!Jump if ACC = ZERO to end of loop
		SJMP 	C1								;#!If not start the loop again
C2:		
		RET										;#!return to MAIN routine
;--------------------------------------------------------------------------------------------------#!
readInput:
	i1:	ACALL 	readKey							;#!CALL keypad subroutine to read one number
		ACALL 	validateInput					;#!CALL subroutine to confirm of valid number
		JB		AIF,ERROR						;#!Jump to ERROR routine if AIF = 1
		JB		OIF,ERROR						;#!Jump to ERROR routine if OIF = 1
		ACALL	DATAWRT							;#!CALL subroutine to pass data to LCD
		ANL		A,#0FH							;#!Masking to convert number form ASCII to BCD
		MOV		N1,A							;#!Save number at RAM 
		;;;
	i2:	ACALL 	readKey							;#!CALL keypad subroutine to read one number
		ACALL 	validateInput					;#!CALL subroutine to confirm of valid number
		JB		DIF,i3							;#!Jump to 2nd digit process label if DIF = 1
		JB		OIF,i6							;#!Jump to operator process label if OIF = 1
		JB		AIF,ERROR						;#!Jump to ERROR routine if AIF = 1
		;										;#!2nd input digit for 1st number processing section
	i3:	ACALL	DATAWRT							;#!CALL subroutine so pass data to LCD
		ANL		A,#0FH							;#!Masking to convert number form ASCII to BCD
		MOV		TEMP,A							;#!Hold it temporary at RAM 							
		MOV		A,N1							;#!Get the first digit
		MOV		B,#10							;#!							
		MUL		AB								;#!Multiply as tens 
		ADD 	A,TEMP							;#!Add ones 
		MOV		N1,A							;#!Finally save number again at RAM
		AJMP	i10
		;;;
	i4:	MOV		TEMP,A							;#!
		MOV		A,OP							;#!Check for not to get operator input twice 
		CJNE	A,#0,ERROR						;#!
	i5:	MOV		A,TEMP							;#!
	i6:	ACALL	DATAWRT							;#!CALL subroutine so pass data to LCD
		MOV		OP,A							;#!Save operation at RAM 
		;;;
	i10:ACALL 	readKey							;#!CALL keypad subroutine to read one number
		ACALL 	validateInput					;#!CALL subroutine to confirm of valid number
		JB		OIF,i4							;#!Jump to ERROR routine if OIF = 1
		JB		AIF,ERROR						;#!Jump to ERROR routine if AIF = 1
	i7:	ACALL	DATAWRT							;#!CALL subroutine so pass data to LCD
		ANL		A,#0FH							;#!Masking to convert number form ASCII to BCD
		MOV		N2,A							;#!Save number at RAM
		;;;
		ACALL 	readKey							;#!CALL keypad subroutine to read one number
		ACALL 	validateInput					;#!CALL subroutine to confirm of valid number
		JB		DIF,i8							;#!Jump to ERROR routine if DIF = 1
		JB		OIF,ERROR						;#!Jump to ERROR routine if OIF = 1
		JB		AIF,i9							;#!Jump to ERROR routine if AIF = 1
	i8:	ACALL	DATAWRT							;#!2nd digit for 2nd number processing section
		ANL		A,#0FH							;#!
		MOV		TEMP,A							;#!
		MOV		A,N2							;#! 
		MOV		B,#10							;#!
		MUL		AB								;#!
		ADD 	A,TEMP							;#!
		MOV		N2,A							;#!
		;;;
		ACALL 	readKey							;#!CALL keypad subroutine to read assignemt operation (=)
		ACALL 	validateInput					;#!CALL subroutine to confirm of valid input
		JB		DIF,ERROR						;#!Jump to ERROR routine if OIF = 1
		JB		OIF,ERROR						;#!Jump to ERROR routine if OIF = 1
	i9:	ACALL	DATAWRT							;#!CALL subroutine so pass data to LCD
		AJMP	NOERROR							;#!Jump to END of subroutine if NO ERROR
ERROR:	ACALL	ERRFUN							;#!CALL ERROR subroutine if input was not valid
		LJMP	MAIN							;#!return if ERROR to start of program again
NOERROR:
		RET										;#!return if NO ERROR normally to MAIN
;--------------------------------------------------------------------------------------------------#!
calculateResult:
		MOV		A,N1							;#!Copy first number to ACC
		MOV		B,N2							;#!Copy second number to B
		MOV		R0,OP							;#!Copy operation to R7
		CJNE 	R0,#"+",NEXT11					;#!Check firstly if the operation was "+", if not jump
		ADD		A,B								;#!If so, Add the two operands
		MOV		R,A								;#!Save result at RAM 
		MOV		SIGN,#"+"						;#!Set result sign to positive
		RET										;#!return to MAIN 
		;
NEXT11:	CJNE	R0,#"-",NEXT22					;#!Check secondly if the operation was "-", if not jump
		SUBB	A,B								;#!If so, Sub the two operands 
		JC		NIGATIV							;#!Check on carry for nigative result
		MOV		R,A								;#!Save result at RAM 
		MOV		SIGN,#"+"						;#!Set result sign to positive
		RET										;#!return to MAIN
NIGATIV:CPL		A								;#!Convert to 1's complement if negativ
		INC 	A								;#!Incremet to get 2's complement 
		MOV		R,A								;#!Save result at RAM
		MOV		SIGN,#"-"						;#!Set result sign to nigative
		RET										;#!return to MAIN
		;
NEXT22:	CJNE	R0,#"*",NEXT33					;#!Check thirdly if the operation was "*", if not jump
		MUL		AB								;#!If so, Multibly the oeprands
		MOV		R,A								;#!Save result in RAM
		MOV		H,B								;#!Save result's hight byte at RAM
		MOV		SIGN,#"+"						;#!Set result sign to positive
		RET										;#!return to MAIN
		;
NEXT33:	CJNE	R0,#"/",ERROR					;#!Check finally if the operation was "/", if not jump
		MOV		A,N2							;#!Make sure first that you don't divide by zero
		JZ		ERROR							;#!If zero, terminate and print error msg
		MOV		A,N1							;#!if not, complete normally
		MOV		TEMP,B							;#!Copy to TEMP location 
	OK: DIV		AB								;#!Carry out division to the two operands 
		MOV		R,A								;#!Save the quotient in RAM 
		MOV		A,#10							;#!Fill ACC with 10
		MUL		AB								;#!Multibly reminder by 10
		MOV		B,TEMP							;#!Get the second number again
		DIV		AB								;#!Divide again 
		MOV		F,A								;#!Save the digit after decimal point at RAM 
		MOV		SIGN,#"+"						;#!Set result sign to positive
		RET										;#!return to MAIN 
;--------------------------------------------------------------------------------------------------#!
printOutput:
		MOV 	R1,#00D							;#!Clear R1   
        MOV 	R2,#00D							;#!Clear R2
        MOV 	R3,#00D							;#!Clear R3 
        MOV 	R4,#00D							;#!Clear R4 
		;
		MOV		A,SIGN							;#!Copy SIGN contents to R6
		CJNE	A,#"-",UNSIGN					;#!Check on sign if positive or negative					
		ACALL	DATAWRT							;#!IF signed, print first negative sign on LCD 
		;
UNSIGN:	MOV 	A,R								;#!Get the low data byte 
		MOV 	B,#10D  
        DIV 	AB								;#!Divide it by 10
        MOV 	R1,B							;#!Save the first digit in R1
        MOV 	B,#10D 							 
        DIV 	AB								;#!Divide by 10 once more
        MOV 	R2,B							;#!Save the next digit in R2
        MOV 	R3,A							;#!Save the last digit in R3
		;
		MOV		A,H								;#!Get the high data byte
        CJNE 	A,#0,NEXT						;#!Check on it
        LJMP	PRINT 							;#!If it contains nothing, Jump to print output
		;
NEXT:	MOV 	A,#6							;#!If there was Value at DB1, Decrement and..
        ADD 	A,R1							;#!Add 265 to corresponding digits on R1, R2 & R3
        MOV 	B,#10
        DIV 	AB
        MOV 	R1,B							;#!Save remainder after adding 6 on R1
		;
        ADD 	A,#5
        ADD 	A,R2
        MOV 	B,#10
        DIV 	AB
        MOV 	R2,B							;#!Save remainder after adding 5 on R2
		;
        ADD 	A,#2
        ADD 	A,R3
        MOV 	B,#10
        DIV 	AB
        MOV 	R3,B							;#!Save remainder after adding 6 on R3
		;
		ADD 	A,R4
        MOV 	R4,A							;#!Save remainder on R4
		DJNZ 	H,NEXT							;#!Decrement H and do process if it still not zero
		;
PRINT:	MOV 	A,R4							;#!Get output data form R4
		JNZ		PRINT1
		CLR 	PZF
		AJMP	L1
PRINT1: ADD		A,#30H							;#!Convert to ASCII
        ACALL	DATAWRT							;#!Print on LCD
		SETB	PZF
        ;
	L1:	MOV 	A,R3							;#!Get output data form R3
		JNZ		PRINT2
		JNB		PZF,L2
PRINT2: ADD		A,#30H							;#!Convert to ASCII
        ACALL	DATAWRT							;#!Print on LCD
		SETB 	PZF
        ;
    L2: MOV 	A,R2							;#!Get output data form R2
		JNZ		PRINT3
		JNB		PZF,L3
PRINT3: ADD		A,#30H							;#!Convert to ASCII
        ACALL	DATAWRT							;#!Print on LCD
		SETB 	PZF
        ;
    L3: MOV 	A,R1							;#!Get output data form R1
		JNZ		PRINT4
PRINT4: ADD		A,#30H							;#!Convert to ASCII
        ACALL	DATAWRT							;#!Print on LCD
		;
		MOV		A,F								;#!Check if the result was decimal point number
		CJNE	A,#0,POINTED					;#!.
		AJMP 	DONE							;#!.
		;
POINTED:MOV		A,#"."							;#!Print float ppint and digit code fragment 
		ACALL	DATAWRT							;#!
		MOV		A,F								;#!
		ADD		A,#30H							;#!
		ACALL	DATAWRT							;#!
		;
DONE:	AJMP	LDELAY							;#!Give some time to result on LCD						
		AJMP	LDELAY							;#!
		AJMP 	LDELAY							;#!
        RET
;--------------------------------------------------------------------------------------------------#!	
validateInput:									;#!Detemine and set flags for each kind of input
		CJNE	A,#"+", next1					;#!Check if input is add operator,
		AJMP	found							;#!Jump to found if input match with (+,-,*,/)
next1:	CJNE	A,#"-", next2					;#!Check if input is sub operator,
		AJMP	found							;#!Jump to found if input match with (+,-,*,/)
next2:	CJNE	A,#"*", next3					;#!Check if input is multiply operator 
		AJMP	found							;#!Jump to found if input match with (+,-,*,/)
next3:	CJNE 	A,#"/", next4					;#!Check if input is add operator,
		AJMP	found							;#!Jump to found if input match with (+,-,*,/)
next4:	CJNE	A,#"=", next5					;#!Check if input is assignment operator
		CLR		DIF								;#!CLR digit input flag for non numbers
		CLR		OIF								;#!CLR operation input flag for non operation 
		SETB	AIF								;#!SET assignment input flag for (=)
		RET										;#!return to MAIN
next5:	SETB	DIF								;#!SET digit input flag for numbers
		CLR		OIF								;#!CLR operation input flag for non operatio
		CLR		AIF								;#!CLR assignment input flag if not (=)
		RET										;#!return to MAIN
found:	CLR		DIF								;#!CLR digit input flag for non numbers
		SETB	OIF								;#!SET operation input flag for any of operations
		CLR		AIF								;#!CLR assignment input flag if not (=)
		RET										;#!return
;--------------------------------------------------------------------------------------------------#!
readKey:
		MOV 	P1,#0FFH						;#!Make P1 an input port
K1: 	MOV 	P3,#0                           ;#!Ground all rows at once
		MOV 	A,P1							;#!Read all colums 
		ANL 	A,#00001111B					;#!Masked unused bits
		CJNE 	A,#00001111B,K1                 ;#!Till all keys release
K2: 	LCALL 	SDELAY                          ;#!Call 20 msec delay
		MOV 	A,P1                            ;#!See if any key is pressed
		ANL 	A,#00001111B                    ;#!Mask unused bits
		CJNE 	A,#00001111B,OVER               ;#!Key pressed, find row
		SJMP 	K2                              ;#!Check till key pressed
OVER: 	LCALL 	SDELAY                          ;#!Wait 20 msec debounce time
		MOV 	A,P1                            ;#!Check key closure
		ANL 	A,#00001111B                    ;#!Mask unused bits
		CJNE 	A,#00001111B,OVER1              ;#!Key pressed, find row
		SJMP 	K2                            	;#!If none, keep polling
OVER1: 	MOV 	P3,#11111110B                 	;#!Ground row 0
		MOV 	A,P1                            ;#!Read all columns
		ANL 	A,#00001111B                    ;#!Mask unused bits
		CJNE 	A,#00001111B,ROW_0              ;#!Key row 0, find col.
		MOV 	P3,#11111101B                   ;#!Ground row 1
		MOV 	A,P1                            ;#!Read all columns
		ANL 	A,#00001111B                    ;#!Mask unused bits
		CJNE 	A,#00001111B,ROW_1              ;#!Key row 1, find col.
		MOV 	P3,#11111011B                   ;#!Ground row 2
		MOV 	A,P1                            ;#!Read all columns
		ANL 	A,#00001111B                    ;#!Mask unused bits
		CJNE 	A,#00001111B,ROW_2              ;#!Key row 2, find col.
		MOV 	P3,#11110111B                   ;#!Ground row 3
		MOV 	A,P1                            ;#!Read all columns
		ANL 	A,#00001111B                    ;#!Mask unused bits
		CJNE 	A,#00001111B,ROW_3              ;#!Key row 3, find col.
		LJMP 	K2                              ;#!If none, false input, repeat
ROW_0: 	MOV 	DPTR,#KCODE0                    ;#!Set DPTR=start of row 0
		SJMP 	FIND                            ;#!Find col. Key belongs to
ROW_1: 	MOV 	DPTR,#KCODE1                    ;#!Set DPTR=start of row
		SJMP 	FIND                            ;#!Find col. Key belongs to
ROW_2: 	MOV 	DPTR,#KCODE2                    ;#!Set DPTR=start of row 2
		SJMP 	FIND                            ;#!Find col. Key belongs to
ROW_3: 	MOV 	DPTR,#KCODE3                    ;#!Set DPTR=start of row 3
FIND: 	RRC 	A                               ;#!See if any CY bit low
		JNC 	MATCH                           ;#!If zero, get ASCII code
		INC 	DPTR                            ;#!Point to next col. addr
		SJMP 	FIND                            ;#!Keep searching		
MATCH: 	CLR 	A                               ;#!Set A=0 (match is found)
		MOVC 	A,@A+DPTR                       ;#!Get ASCII from table
		JZ		CLSCB
		RET										;#!return
CLSCB:	
		LJMP 	MAIN
;--------------------------------------------------------------------------------------------------#!
ERRFUN:	ACALL 	CLS								;#!CALL subroutine to clear screen
		MOV 	DPTR,#ERRMSG					;#!Set DPTR to look-up table's address
E1: 	CLR 	A								;#!Clear ACC
		MOVC 	A,@A+DPTR						;#!Get code from look-up table and placing it into ACC
		ACALL 	DATAWRT							;#!CALL LCD command write subroutine 						
		ACALL 	SDELAY							;#!Give LCD some time 							
		INC 	DPTR							;#!Increment DPTR <DPTR = DPTR + 1>
		JZ 		E2								;#!Jump if ACC = ZERO to end of loop
		SJMP 	E1								;#!If not start the loop again
E2:		ACALL	LDELAY							;#!Give some time to msg on screen 
		ACALL	CLS								;#!CALL subroutine to clear screen again
		RET										;#!return
;--------------------------------------------------------------------------------------------------#!
COMMWRT:										;#!Send command to LCD							
		MOV 	P2,A 							;#!Copy reg A to P1
		CLR 	P0.0 							;#!RS=0 for command
		CLR 	P0.1 							;#!R/W=0 for write
		SETB 	P0.2 							;#!E=1 for high pulse
		ACALL 	SDELAY 							;#!Give LCD some time
		CLR 	P0.2 							;#!E=0 for H-to-L pulse
		RET										;#!return to caller
;--------------------------------------------------------------------------------------------------#!
DATAWRT:										;#!Write data to LCD
		MOV 	P2,A 							;#!Copy reg A to port 1
		SETB 	P0.0 							;#!RS=1 for data
		CLR 	P0.1 							;#!R/W=0 for write
		SETB 	P0.2 							;#!E=1 for high pulse
		ACALL 	SDELAY 							;#!Give LCD some time
		CLR 	P0.2 							;#!E=0 for H-to-L pulse
		RET										;#!return to caller
;--------------------------------------------------------------------------------------------------#!
CLS:											;#!CLear Screen subroutine
		MOV 	A,#01H							;#!Fill ACC with the command code 
		ACALL 	COMMWRT							;#!CALL subroutine to send code to lCD 
		RET										;#!return to caller
;--------------------------------------------------------------------------------------------------#!
SDELAY:											;#!Short Delay subroutine
		PUSH	01
		MOV 	R0,#50							;#!R0 = 50
S11:	MOV 	R1,#255							;#!R1 = 255
S21:	DJNZ 	R1,S21							;#!stay here until R1 becomes ZERO			   			       
		DJNZ 	R0,S11							;#!
		POP		01
		RET										;#!return to caller
;--------------------------------------------------------------------------------------------------#!		
LDELAY:											;#!Long Delay Subroutine
		PUSH 	01
		PUSH 	02
		MOV		R0,#7							;#!R0 = 7
L33:	MOV		R1,#190							;#!R1 = 190
L22:	MOV		R2,#255							;#!R2 = 255
L11:	DJNZ	R2,L11							;#!stay here until R2 becomes ZERO
		DJNZ	R1,L22							;#!
		DJNZ	R0,L33							;#!
		POP		01
		POP		02
		RET										;#!return to caller
;--------------------------------------------------------------------------------------------------#!
;--------------------------------------------------------------------------------------------------#!
;-------COMMANDS LOOK-UP TABLE FOR LCD INITIALIZATION
		ORG		300H
MYCOM: 	DB 		38H,0FH,01H,06H,80H,0
;-------ASCII LOOK-UP TABLE FOR EACH ROW			
KCODE0: DB 		"7","8","9","/" 				;#!ROW 0
KCODE1: DB 		"4","5","6","*" 				;#!ROW 1
KCODE2: DB 		"1","2","3","-" 				;#!ROW 2
KCODE3: DB 		0,"0","=","+" 					;#!ROW 3
;-------ERROR MASSAGE FOR ANY INVALID INPUT
ERRMSG:	DB		"ERROR!!",0
		END
;######################################################################################################                                                                                                          
;#                                                                                                    #       
;#                                                 .;-=+##x+---;..                                    #      
;#                                            -xX#########X#######X=.                                 #     
;#                                         ;=X########XxXXXxxxxxxX#####X=,                            #      
;#                                      ;X####Xx######xxx+xX##Xx+xxxxxxx+#x                           #      
;#                                    =X###xxx++++xxx+++++xX#XXXXXXxxxxxx=X#X,                        #      
;#                                  -###XXxx######################Xxxxx##+=x##x-                      #      
;#                                .###XX##XX###############x####XXX#XX####x+++x##=                    #      
;#                                ###xxX##Xx####X+=-XxxXxX#########Xx#########x+x#-                   #      
;#                               ##xxxX#Xx###xx+    x;-=X###X##################XX#x                   #        
;#                              =##X###XX###= -.    -#x+Xx.    -+xX##############XX                   #        
;#                              ######XxXx=                             .....;+xxx#+                  #        
;#                             -####XXXXx                                      ,+###-                 #        
;#                             ##X#XXXXx.                                       .##x#-                #        
;#                             #X##X#Xx-                                         =#XXx                #        
;#                            -###X##x+=;.                                         xx#.               #        
;#                            ###X#XX#++=-                                         .##,               #        
;#                            #XXXX#XXxxx-                                          ##                #        
;#                            ###XxXXXxX+.                                          x#                #        
;#                            ,######X#x.                                           #x                #        
;#                           - .#####X=      .     ,;;-,.                          -#+                #        
;#                          -+   -##X+     .. .=X##########x-,.                    X#                 #        
;#                          =,    ,X#-   ... ,=##Xxx++++######=;;..        ..     .#X                 #        
;#                          .  .,  x#        .,,-+xxXXX##XxxX#X=------=+########+ ,#.                 #        
;#                           .-x+  =x          .-=++###x +Xx++=-;;--=+X####Xxxx##=-=                  #        
;#                          ,--   ;=             ...;-. -+=-=-,    .X#####Xx+-,;.                     #       
;#                                ;+              .,;-===-;..       #x+XXX.;Xx;                       #       
;#                                 -+                                ,;,,,, .                         #        
;#                                 =+  ...                              .,,,                          #        
;#                            .    ;+. ..                                                             #        
;#                            - .. -=....            .,,;.             .                              #        
;#                               ,.-=,....  ........;-;,-.              -,                            #        
;#                                  ;;.....;--;,.;=+-.  .,;;,.          ;=-.                          #        
;#                               .  .-....-xX,..+#X+;. ..-x###X+-,.,--. .;=-,.  .                     #        
;#                               .   -;...;X# .+##+-.   .,;=x########X-..;=+-,,.                      #        
;#                              ,... ,=,...+#..-=-x#X+==-;,.  .,-==-,..,,-=#+.,.                      #        
;#                              .,..  -=,..,x.  ,  +###+;=-==;--;;;;,;...=+#= ;                       #        
;#                              .;-.. .==;..-;....   -+;            X##X-=+- ,.                       #        
;#                             ..,-;.. ;x=-,,;,,;,      .,,.       .#+,  ;, ..                        #        
;#                .--,....      .;=-,,.-xx==+=-+=,      ..,,,,;;--,    ., ,                           #       
;#                 =+++++++=--,    .==-;,-XX+++=+x+,........           ,-,;                           #        
;#                ,---==-;--=+xx+;   .-==;-xXx++xx+; ..,,,;----;;,....,++,                            #        
;#                ,...,;--====++xxx-   .++=-+XXxxX+;.     ..;-===;... =x.                             #        
;#                ;.  .,;;;-----==+xx-   =x+-=xX###+=,               .#.                              #        
;#                .         ;==--===+xx;  ,xx+=+x####X=;,           -X;                               #        
;#                            ,======++Xx   +x++==X####Xx+-;--;,;-=XX.                                #        
;#                              .=+====+x#-  =+===-=x##########X##x-                                  #        
;#         .,,,,...               ,+==++++#x  =+==---==++xXXXx+=.                                     #        
;#       ,;----------;.            =-==++xxXX; ;=---;;;--==-.                                         #        
;#    .;;-;,;;;;;;-===+=,          -,;-==+++xX= .-;;,..,,;;,                                          #        
;#  ;---;;;;---;-------=+;         -;,;;--==+xX+..;;,,. ..                                            #        
;#---------------------+;       ,=;;-;;;;-=++xX, ;;;......                                            #      
;#--==------------------==+.      ,=----------==xX, ,-;;,,..                                          #        
;#===--------------------===       =--=--=------=+x=,  ,;,.                                           #        
;#-;;------======----------+;      --------=---=--=+x=.                                               #        
;#--=----=============-----==      -----------===----+x+=;                                            #       
;#=-=--=====================+.     -=---;---------==--=++x+                                           #        
;#------------------=--------;     .--------------------;;;                Author: Mustafa Okasha	  #
;######################################################################################################